#! /usr/bin/python3
# -*- coding: utf-8 -*-
""" VenC v0.0.0 """
""" Licence GNU/GPLv3 """

import VenC.languages as lang
import VenC.core
import yaml
import time
import os

class generic():
    class keyword():
         def __init__(self, keyword, keywordsDict, url, identifier, originalDate = None):
             self.Name = keyword
             if identifier == "dates":
                 self.Mass	= getattr(keywordsDict[keyword], "dateMass")

             elif identifier == "category" and keywordsDict == None:
                 self.Mass	= 0

             else:
                 self.Mass	= getattr(keywordsDict[keyword], identifier+"Mass")

             self.URL	= VenC.core.replaceCharacter(url)

             self.identifier = identifier
             if identifier == "category":
                 self.Node = keyword.split('\t')[-1]
                 self.Branch = self.Name

             elif identifier == "dates":
                i = 0;
                for datePart in ["Month","Day","Year","Hour","Minute"]:
                    setattr(self, datePart, originalDate.split('-')[i])
                    i+=1

         def get(self,argv):
             try:
                 if self.identifier == "category" and len(argv) == 2:

                     #######################################################################
                     #  Argv[1] is the used defined separator between each sub categories  #
                     #######################################################################

                     return str(getattr(self, argv[0])).replace('\t', argv[1])

                 else:
                     return str(getattr(self, argv[0]))

             except AttributeError:
                 return str()

    def processFilename(self, template, offset, entryName):
        pageNumber = str(self.navigationTool["pageNumber"] + offset)
        if len(pageNumber) == 1 and pageNumber == '0':
            pageNumber = ''

        filenameContext = {"{page_number}": pageNumber,
                          "{entry_id}": str(self.navigationTool["pageNumber"] + offset),
                          "{entry_name}": entryName,
                          ".:getTargetPage|URL:.": self.blogConfiguration["path"][self.navigationTool["filenameType"]],
                          ".:getTargetPage|PageNumber:.": str(self.navigationTool["pageNumber"] + offset)}

        while [var for var in filenameContext.keys() if var in template] != list():
            for var in filenameContext.keys():
                 template = template.replace(var, str(filenameContext[var]))

        return template

    ###################################################################
    #                                                                 #
    # Interface between the actual class and the template processor.  #
    # argv[0] define which method will be called. Index higher than 0 #
    # are arguments for the called methods.                           #
    #                                                                 #
    ###################################################################
             
    def get(self, argv):
        if len(argv) == 0:
            return str()

        if argv[0] == "Tags" and len(argv) == 2:
            return self.getKeywords(argv[1], self.tags, "tag")

        elif argv[0] == "Authors" and len(argv) == 2:
            return self.getKeywords(argv[1], self.authors, "author")

        elif argv[0] == "Date" and len(argv) >= 2:
            return self.getDate(argv[1])

        elif argv[0] == "Dates" and len (argv) == 2:
            return self.getKeywords(argv[1], self.dates, "dates")

        elif argv[0] == "Categories" and len (argv) == 2:
            return self.getKeywords(argv[1], self.categories, "category")

        elif argv[0] == "Categories" and len (argv) == 3 and argv[1] == "Tree" and self.__class__.__name__ == "blog":
            return self.categoriesTree(argv[2], self.categories)

        elif argv[0] == "Navigation" and len(argv) >= 3 and argv[1] in ["Next","Previous","List"] and self.__class__.__name__ == "blog":
            return self.navigation(argv[1:])

        elif argv[0] == "if context":
            return self.ifContext(argv[1:])

        elif argv[0] == "pageNumber" and self.__class__.__name__ == "blog":
            return self.getPageNumber(argv[1:])

        else:
            try:
                return getattr(self, argv[0])
 
            except:
                return str()

    def ifContext (self, argv):
        if argv[0] == "single entry" and self.navigationTool["filenameType"] == "entry_file_name":
            return argv[1]

        elif argv[0] == "thread" and self.navigationTool["filenameType"] == "index_file_name":
            return argv[1]

        return str()

    def getDate(self, identifier, f0rmat=None): # f0rmat not implemented yet
        try:
            if identifier in ["Day","Month","Year","Hour","Minute"]:
                return getattr(self, identifier)

            elif identifier == "URL":
                return VenC.core.replaceCharacter(getattr(self, "dateURL"))
 
            else:
                return str()
 
        except:
            return str()
 
    ###########################################################################################################################################
    #  Because this function try to be generic, we need an identifier -"tag","author","date" or "category"- that help to grab right property  #
    ###########################################################################################################################################

    def getKeywords(self, template, source, identifier):
        keywords = dict()
        try:
            template = open(os.getcwd()+'/theme/'+template).read()

        except FileNotFoundError as e:
            print(lang.err[6].format(e.filename))
            return str()

        output = str()

        for keyword in source:
            ######################################################################################################################################
            #  There are many ways to display date and we must link the formated dates with each component in the list of date we're outputing.  #
            ######################################################################################################################################

            if identifier == "dates":

                ###################################################################################
                #  We don't wan't to have twice or more the same index in our dictionnary.        #
                #  If user want to access some filtered datas, it will output unexpected string.  #
                ###################################################################################
                
                if not keyword in keywords.keys():
                    keywords[keyword] = self.keyword(keyword, self.keywordsDict, self.pathProcessor.output(keyword), identifier, originalDate = source[keyword].originalDate)
            else:
                keywords[keyword] = self.keyword(keyword, self.keywordsDict, self.pathProcessor.output(keyword), identifier)
        
        keywordsProcessor = VenC.core.templateProcessor(".:",":.","|",dict())

        for keyword in sorted(keywords.keys()):
            keywordsProcessor.functions["getKeyword"] = keywords[keyword].get
            output += keywordsProcessor.parse(template)

        return output

class entry(generic):
    def __init__(self, filename, keywordsDict, blogConfiguration, pathProcessor, navigationTool):

        ######################
        # Set external datas #
        ######################

        self.blogConfiguration	= blogConfiguration
        self.keywordsDict	= keywordsDict
        self.raw		= open(os.getcwd()+"/entries/"+filename, 'r').read()
        stream			= yaml.load(self.raw.split("---\n")[1][:-1])
        for key in stream:
            setattr(self, key, stream[key])
        self.pathProcessor	= pathProcessor
        self.navigationTool	= navigationTool
        self.Root		= self.pathProcessor.output('')
        self.entry_id		= filename.split("__")[0]

        ###################
        # Set local datas #
        ###################

        self.tags = [tag for tag in stream["tags"].split(',') if tag != '']
        self.date = filename.split("__")[1]
        self.Month = self.date.split('-')[0]
        self.Day = self.date.split('-')[1]
        self.Year = self.date.split('-')[2]
        self.Hour = self.date.split('-')[3]
        self.Minute = self.date.split('-')[4]
        self.URL = VenC.core.replaceCharacter(self.pathProcessor.output('')+self.processFilename(blogConfiguration["path"][self.navigationTool["filenameType"]], int(self.entry_id) - self.navigationTool["pageNumber"], filename.split("__")[2]))
        self.dateURL = self.pathProcessor.output(time.strftime(blogConfiguration["path"]["dates_directory_name"], time.strptime(self.date,"%m-%d-%Y-%M-%S")))
        self.authors = [author for author in stream["authors"].split(',') if author != '']
        self.categories = [category for category in stream["categories"].split(',') if category != '']
        self.Content = '\n'.join([part for part in self.raw.split("---\n")[2:] if part != ''])

class blog(generic):
    class node():
        def __init__(self, keyword=None):
            self.edges =  dict()
            self.keyword = keyword

    def __init__(self, keywordsDict, blogConfiguration, pathProcessor, navigationTool):
        self.blogConfiguration	= blogConfiguration
        self.navigationTool	= navigationTool
        self.pathProcessor	= pathProcessor
        self.keywordsDict	= keywordsDict
        self.categories		= dict()
        self.authors		= dict()
        self.dates		= dict()
        self.Root		= self.pathProcessor.output('')
        self.tags		= dict()
        self.page_number	= str(navigationTool["pageNumber"])
        for index in blogConfiguration.keys():
            setattr(self, index, blogConfiguration[index])

        for keyword in keywordsDict.keys():
             if keywordsDict[keyword].tagMass != 0:
                 self.tags[keyword] = keywordsDict[keyword]

             if keywordsDict[keyword].dateMass != 0:
                 self.dates[keyword] = keywordsDict[keyword]

             if keywordsDict[keyword].authorMass != 0:
                 self.authors[keyword] = keywordsDict[keyword]

             if keywordsDict[keyword].categoryMass != 0:
                 self.categories[keyword] = keywordsDict[keyword]

    def getPageNumber(self, argv):
        if self.navigationTool["filenameType"] == "index_file_name":
            return str(int(self.page_number)+1)
        return self.page_number
            
    def navigation(self, argv):
        template = str()
        output = str()
        try:
            template = open(os.getcwd()+"/theme/"+argv[1]).read()

        except FileNotFoundError as e:
            return str()

        if not self.navigationTool["totalPages"] > 1:
                return str() 

        if argv[0] == "Next":

            if self.navigationTool["pageNumber"] <= self.navigationTool["totalPages"]:
                if self.navigationTool["filenameType"] == "index_file_name" and not self.navigationTool["pageNumber"] < self.navigationTool["totalPages"] - 1:
                    return str()
                else:
                    return self.processFilename(template, 1, '')

            else:
                return str()

        if argv[0] == "Previous":
            if self.navigationTool["pageNumber"] > 0:
                if self.navigationTool["filenameType"] == "entry_file_name" and self.navigationTool["pageNumber"] == 1:
                    return str()
                else:
                    return self.processFilename(template, -1, '')

            else:
                return str()

        if argv[0] == "List":

            i = 0
            while i < int(argv[2]):
                if self.navigationTool["pageNumber"] - int(argv[2]) + i >= 0:
                    output += self.processFilename(template, - int(argv[2]) + i, '')
                i+=1

            output += self.processFilename(template, 0, '')
            i = 1
            while self.navigationTool["pageNumber"] + i < self.navigationTool["totalPages"] and i <= int(argv[2]):
                output += self.processFilename(template, i, '')
                i +=1
            return output

    #####################################################
    #  Recursive method aimed to ouput a category tree  #
    #####################################################
    
    def categoriesTree(self, templateSource, keywordsDict):
        ###########################
        #  we first build a tree  #
        ###########################
        tree = self.node()
        currentNode = tree.edges
        for category in keywordsDict.keys():
            categorySplit = category.split('\t')
            for subCategory in categorySplit:
                if not subCategory in currentNode.keys():
                    currentNode[subCategory] = self.node()

                if subCategory == categorySplit[-1]:
                    currentNode[subCategory].keyword = self.keyword(category, keywordsDict, self.pathProcessor.output(category), "category")

                else:
                    branch = list()
                    for node in categorySplit:
                        branch.append(node)
                        if node == subCategory:
                            break

                    currentNode[subCategory].keyword = self.keyword('\t'.join(branch), None, '',"category")

                currentNode = currentNode[subCategory].edges
            currentNode = tree.edges

        try:
            template = open(os.getcwd()+"/theme/"+templateSource).read()

        except FileNotFoundError as e:
            print(lang.err[6].format(e.filename))
            return str()

        return self.outputCategoriesTree(template, tree)

    def outputCategoriesTree(self, template, node):
        output = str()
        edgeProcessor = VenC.core.templateProcessor(".:",":.",'|')
        for edge in sorted(node.edges.keys()):
            preProcessedTemplate = template.replace(".:getNode:.", self.outputCategoriesTree(template, node.edges[edge]))
            edgeProcessor.functions["getKeyword"] = node.edges[edge].keyword.get
            output+= edgeProcessor.parse(preProcessedTemplate)

        return output
