#i! /usr/bin/python3
# -*- coding: utf-8 -*-
""" VenC-0.0.0 """
""" Licence GNU/GPLv3 """

import VenC.languages as lang
import VenC.core
import shutil
import yaml
import os

def exportBlog(argv):

     ##########################################
     #  Load template and blog configuration  #
     ##########################################

     try:
         templates = dict()
         blogConfiguration = yaml.load(open(os.getcwd()+"/blog_configuration.yaml",'r').read())
         themeDirIndex = os.listdir(os.getcwd()+"/theme/")
         if len([None for x in ["header.html","footer.html","entry.html"] if x in themeDirIndex]) != 3:
             print(lang.err[8])

         for template in os.listdir(os.getcwd()+"/theme/"):
             templates[template] = open(os.getcwd()+"/theme/"+template,'r').read()

     except FileNotFoundError as e:
         print(lang.err[6].format(e.filename))
         exit()


     ###############################################
     #  Set which kind of thread will be exported  #
     ###############################################

     threadOrder	= bool()
     getTags		= VenC.core.quickTemplatesProcessing(templates, [".:getEntry|Tags", ".:getBlog|Tags"])
     getDates		= VenC.core.quickTemplatesProcessing(templates, [".:getBlog|Dates", ".:getBlog|Dates",".:getEntry|Date|URL:."])
     getAuthors		= VenC.core.quickTemplatesProcessing(templates, [".:getEntry|Authors", ".:getBlog|Authors"])
     getCategories	= VenC.core.quickTemplatesProcessing(templates, [".:getEntry|Categories", ".:getBlog|Categories"])
     getSingleEntries	= VenC.core.quickTemplatesProcessing(templates, [".:getEntry|URL:."])
     getRss		= True
     keywordsDict = VenC.core.getKeywords(getTags, getDates, getAuthors, getCategories, blogConfiguration)
     ########################
     #  Paging all entries  #
     ########################

     try:
         if blogConfiguration["thread_order"] in ["newest first", "latest first"]:
             threadOrder = True
         elif blogConfiguration["thread_order"] == "oldest first":
             threadOrder = False
 
         defaultEntriesList = VenC.core.getEntries(True)
         pages = VenC.core.paging(blogConfiguration["entries_per_pages"], defaultEntriesList, threadOrder)
         VenC.core.exportThread(pages, blogConfiguration, keywordsDict, blogConfiguration["path"], templates, "root", "index_file_name")
         if getTags:
             VenC.core.highLevelExportThread(keywordsDict, blogConfiguration, "tag", threadOrder, templates, "index_file_name")

         if getDates:
             VenC.core.highLevelExportThread(keywordsDict, blogConfiguration, "date", threadOrder, templates, "index_file_name")
  
         if getAuthors:
             VenC.core.highLevelExportThread(keywordsDict, blogConfiguration, "author", threadOrder, templates, "index_file_name")

         if getCategories:
             VenC.core.highLevelExportThread(keywordsDict, blogConfiguration, "category", threadOrder, templates, "index_file_name")

         if getSingleEntries:
             pages = VenC.core.paging(1, defaultEntriesList, False)
             VenC.core.exportThread(pages, blogConfiguration, keywordsDict, blogConfiguration["path"], templates, "root", "entry_file_name")

         if getRss:
            pages = VenC.core.paging(blogConfiguration["rss_thread_lenght"], defaultEntriesList, True)
            VenC.core.exportThread([pages[0]], blogConfiguration, keywordsDict, blogConfiguration["path"], templates, "rss","rss_file_name")
         ##############################################
         #  Copying all stylesheet to blog directory  #
         ##############################################

         for _file_ in os.listdir(os.getcwd()+"/theme/"):
             if _file_.split('.')[-1].lower() in ["css","png","jpg","jpeg","js","gif","bmp","svg"]:
                shutil.copy(os.getcwd()+"/theme/"+_file_, os.getcwd()+"/blog/"+_file_)
     except FileNotFoundError as e:
         raise
         print(lang.err[6].format(e.filename))
         exit()

     except KeyError as e:
         raise
         print(lang.err[7].format(e.args[0]))
         exit()
